; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
;																				
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
; *	0 		1 	1 		8														
;	1 		0 	0 		16														
;	1 		0 	1	 	32														
; 	1 		1 	0 		64														
;	1 		1 	1 		128														
;																				
;																				
; ADC REFERENZ																	
;																				
; REFS1 REFS0 Voltage Reference Selection										
;  0     0    AREF, Internal Vref turned off									
; *0     1    AVCC with external capacitor at AREF pin							
;  1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin	
ADC_INITIALISIERUNG:
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)) 
	out ADCSR, temp
	ldi temp, (0<<REFS1)|(1<<REFS0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_IN_VOLT_TEMP1_2:
	ldi ZL,LOW (5004)
	ldi ZH,HIGH(5004)
	mov R0,temp1
	mov R1,temp2
	clr temp1
	clr temp2
	clr temp3
ADC_IN_VOLT_s:
	add temp1,R0
	adc temp2,R1
	adc temp3,NULL
	sbiw ZL,1			; -1
	tst ZL
	brne ADC_IN_VOLT_s
	tst ZH
	brne ADC_IN_VOLT_s
;-------------------------------------------------------------------------------
	; Aufrunden, halber Divisor dazuaddieren	
	subi temp1, BYTE1(-512)
	sbci temp2, BYTE2(-512)
	sbci temp3, BYTE3(-512)
	; durch 1024								
	mov temp1,temp2	; :256	
	mov temp2,temp3
	LSR temp2		; :512	
	ROR temp1
	LSR temp2		; :1024	
	ROR temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Canal 0																		
; OUT:  temp1+temp2																
; 																				
MESSEN_0_TEMP1_2:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -0				; KANAL 0	
	out ADMUX, temp
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU an		
	rcall ADC_MESSEN_TEMP1_2	; OUT: TEMP1 / TEMP2	
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU aus		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
ADC_MESSEN_TEMP1_2:
	WDR
	; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal	
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
MESSEN_w:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp MESSEN_w
; HILFSREGISTER CLEAR											
	clr temp3	
	clr temp4
	clr temp5
	clr temp6
	clr temp8	; SCHLEIFE initialisieren	
; neuen ADC-Wert lesen	(Schleife - 256 mal)								
MESSEN_SCHLEIFE:                
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
MESSEN_SCHLEIFE_w:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt	
	rjmp MESSEN_SCHLEIFE_w
; ADC einlesen:																
	in  temp1, ADCL 			; immer zuerst LOW Byte lesen
	in  temp2, ADCH 			; danach das mittlerweile gesperrte High Byte
; alle 256 ADC-Werte addieren												
	add temp4,temp1     		; addieren  						
	adc temp5,temp2     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
	dec temp8			 		; Schleifenzhler MINUS 1			
	brne MESSEN_SCHLEIFE 		; ==> SCHLEIFE						
; aufrunden	(128 addieren)											
	subi temp4, BYTE1(-128)
	sbci temp5, BYTE2(-128)
	sbci temp6, BYTE3(-128)
; 	Ergebnis durch 256 teilen (temp5+6 nach temp1+2 kopieren)				
	mov temp1,temp5
	mov temp2,temp6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
