; ##############################################################################
; ##############################################################################
; ##############################################################################
; BEGRUNG																		
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	rcall LCD_CLEAR
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ANZEIGE_TEXT
	; ZEILE2	
	rcall LCD_ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ANZEIGE_TEXT
	; ZEILE3		
	rcall LCD_ZEILE3
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall ANZEIGE_TEXT
	; ZEILE4		
	rcall LCD_ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall ANZEIGE_TEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR:
	LDS temp,(adr_ERROR_CODE)
	tst temp	
	brne ANZEIGE_ERROR_RUN
	ret
;-------------------------------------------------------------------------------
ANZEIGE_ERROR_RUN:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an	
	cbi (BEEP_PORT)    ,(BEEP_PIN_NR)		; BEEP an	
	; ZEILE1
	rcall LCD_CLEAR
	rcall LCD_E
	rcall LCD_R
	rcall LCD_R
	rcall LCD_O
	rcall LCD_R
	rcall LCD_SPACE
	LDS temp1,(adr_ERROR_CODE)
	rcall ANZEIGE_HEX_TEMP1
	rcall WAIT_100ms
	sbi (BEEP_PORT)    ,(BEEP_PIN_NR)		; BEEP aus	
;-------------------------------------------------------------------------------
	; ZEILE2
	rcall LCD_ZEILE2
	LDS temp,(adr_ERROR_CODE)
	STS(adr_ERROR_CODE),NULL	; NULL
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SEARCH_AB)
	brne ANZEIGE_ERROR_NO_AB
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rcall LCD_MINUS
	rcall LCD_A
	rcall LCD_B
	ret
ANZEIGE_ERROR_NO_AB:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SEARCH_CRC)
	brne ANZEIGE_ERROR_NO_SEARCH_CRC
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rcall LCD_MINUS
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	ret
ANZEIGE_ERROR_NO_SEARCH_CRC:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SEARCH_ANZAHL)
	brne ANZEIGE_ERROR_NO_SEARCH_ANZAHL
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rcall LCD_MINUS
	rcall LCD_A
	rcall LCD_N
	rcall LCD_Z
	rcall LCD_A
	rcall LCD_H
	rcall LCD_L
	ret
ANZEIGE_ERROR_NO_SEARCH_ANZAHL:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_CRC)
	brne ANZEIGE_ERROR_NO_CRC
	rcall LCD_R
	rcall LCD_O
	rcall LCD_M
	rcall LCD_MINUS
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	; ZEILE3
	rcall LCD_ZEILE3
	rcall ANZEIGE_ROM_ID_KURZ
	ret
ANZEIGE_ERROR_NO_CRC:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_RESET_PRESENCE)
	brne ANZEIGE_ERROR_NO_RP
	rcall LCD_R
	rcall LCD_MINUS
	rcall LCD_P
	rcall LCD_R
	rcall LCD_E
	rcall LCD_S
	rcall LCD_E
	rcall LCD_N
	rcall LCD_C
	rcall LCD_E
	ret
ANZEIGE_ERROR_NO_RP:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_BUS)
	brne ANZEIGE_ERROR_NO_BUS
	rcall LCD_B
	rcall LCD_U
	rcall LCD_S
	ret
ANZEIGE_ERROR_NO_BUS:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_TEMPERATURBERECHNUNG )
	brne ANZEIGE_ERROR_NO_x99
	ret
ANZEIGE_ERROR_NO_x99:
;-------------------------------------------------------------------------------
	cpi temp,(ERROR_OW_SCRATCHPAD_CRC)
	brne ANZEIGE_ERROR_NO_SCRC
	rcall LCD_S
	rcall LCD_C
	rcall LCD_R
	rcall LCD_MINUS
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	; ZEILE3
	rcall LCD_ZEILE3
	rcall LCD_0
	rcall LCD_X_
	LDS temp1,(adr_SCRATCHPAD+8)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+7)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+5)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+2)
	rcall ANZEIGE_HEX_TEMP1
	; ZEILE4
	rcall LCD_ZEILE4
	LDS temp1,(adr_SCRATCHPAD+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+0)
	rcall ANZEIGE_HEX_TEMP1
	ret
ANZEIGE_ERROR_NO_SCRC:
;-------------------------------------------------------------------------------
; unbekannt																		
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SLAVE_FOUND:
	LDS temp1,(adr_ANZAHL_SLAVES)
	rcall ANZEIGE_3_STELLEN_TEMP1
	rcall LCD_SPACE
	rcall LCD_S
	rcall LCD_L
	rcall LCD_A
	rcall LCD_V
	rcall LCD_E
	rcall LCD_S
	rcall LCD_SPACE
	rcall LCD_f_
	rcall LCD_o_
	rcall LCD_u_
	rcall LCD_n_
	rcall LCD_d_
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_FAMILY_KURZ_TEMP1:
	cpi temp1,0x10	; DS18S20 (roter Farbpunkt)
	brne ANZEIGE_TEXT_NO_0x10
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_S
	rcall LCD_2
	rcall LCD_0
	
	rcall LCD_SPACE

	rcall LCD_R
	rcall LCD_0
	rcall LCD_T
	ret
ANZEIGE_TEXT_NO_0x10:
;---------------------------------------------------------------------------
	cpi temp1,0x22	; DS1822 (brauner Farbpunkt)
	brne ANZEIGE_TEXT_NO_0x22
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_2
	rcall LCD_2
	
	rcall LCD_SPACE

	rcall LCD_B
	rcall LCD_R
	rcall LCD_A
	rcall LCD_U
	rcall LCD_N
	ret
ANZEIGE_TEXT_NO_0x22:
;---------------------------------------------------------------------------
	cpi temp1,0x28	; DS18B20 (grner Farbpunkt)
	brne ANZEIGE_TEXT_NO_0x28
	rcall LCD_D
	rcall LCD_S
	rcall LCD_1
	rcall LCD_8
	rcall LCD_B
	rcall LCD_2
	rcall LCD_0
	
	rcall LCD_SPACE

	rcall LCD_G
	rcall LCD_R
	rcall LCD_U
	rcall LCD_E
	rcall LCD_N
	ret
ANZEIGE_TEXT_NO_0x28:
;---------------------------------------------------------------------------
	cpi temp1,0xEF
	brne ANZEIGE_TEXT_NO_0xEF
	rcall LCD_P
	rcall LCD_R
	rcall LCD_I
	rcall LCD_V
	rcall LCD_A
	rcall LCD_T
	ret
ANZEIGE_TEXT_NO_0xEF:
;---------------------------------------------------------------------------
	rcall ANZEIGE_HEX_TEMP1
	ldi temp, 'h'		; 
	rcall LCD_DATA
	rcall LCD_SPACE
	rcall LCD_F
	rcall LCD_A
	rcall LCD_M
	rcall LCD_SPACE
	rcall LCD_FRAGEZEICHEN
	rcall LCD_FRAGEZEICHEN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEMPERATUR_KURZ:
	LDS temp1,(adr_TEMPERATUR_L)
	LDS temp2,(adr_TEMPERATUR_H)
	
	;ldi temp1,LOW (12)
	;ldi temp2,HIGH(12)

	tst temp2
	brpl ANZEIGE_TEMPERATUR_KURZ_POSITIV
;-------------------------------------------------------------------------------
ANZEIGE_TEMPERATUR_KURZ_NEGATIV:
	rcall LCD_MINUS
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
	rjmp ANZEIGE_TEMPERATUR_KURZ_ACTION
;-------------------------------------------------------------------------------
ANZEIGE_TEMPERATUR_KURZ_POSITIV:
	rcall LCD_SPACE
;-------------------------------------------------------------------------------
; NULLSTELLENUNTERDRCKUNG														
ANZEIGE_TEMPERATUR_KURZ_ACTION:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	cpi temp4,'0'
	brne ANZEIGE_TEMPERATUR_KURZ_RUN
	ldi temp4,' '
	cpi temp3,'0'
	brne ANZEIGE_TEMPERATUR_KURZ_RUN
	ldi temp3,' '
;-------------------------------------------------------------------------------
ANZEIGE_TEMPERATUR_KURZ_RUN:
	mov temp, temp4		; 
	rcall LCD_DATA
	mov temp, temp3		; 
	rcall LCD_DATA
	mov temp, temp2		; 
	rcall LCD_DATA
	ldi temp, ','		; 
	rcall LCD_DATA
	mov temp, temp1		; 
	rcall LCD_DATA
	ldi temp, ' '		; 
	rcall LCD_DATA
	ldi temp, 'C'		; 
	rcall LCD_DATA

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ROM_ID_KURZ:
	LDS temp1,(adr_ROM_ID+0)	; FAM	
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+2)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+5)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_ROM_ID+7)	; CRC	
	rcall ANZEIGE_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SCRATCHPAD_KURZ9:
	; ZEILE2	
	rcall LCD_ZEILE2
	rcall LCD_0
	rcall LCD_X_
	LDS temp1,(adr_SCRATCHPAD+8)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+7)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+6)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+5)
	rcall ANZEIGE_HEX_TEMP1
	; ZEILE3
	rcall LCD_ZEILE3
	LDS temp1,(adr_SCRATCHPAD+4)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+3)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+2)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+1)
	rcall ANZEIGE_HEX_TEMP1
	LDS temp1,(adr_SCRATCHPAD+0)
	rcall ANZEIGE_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_R_ON_OFF:
	; ZEILE1
	rcall LCD_CLEAR
	rcall LCD_R
	rcall LCD_MINUS
	rcall LCD_o_
	rcall LCD_n_
	rcall LCD_SPACE
	rcall LCD_SPACE
	LDS temp1,(adr_R_ON)
	rcall ANZEIGE_3_STELLEN_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_CRC_ON_OFF:
	; ZEILE1
	rcall LCD_CLEAR
	rcall LCD_C
	rcall LCD_R
	rcall LCD_C
	rcall LCD_MINUS
	rcall LCD_o_
	rcall LCD_n_
	rcall LCD_SPACE
	rcall LCD_SPACE
	LDS temp1,(adr_CRC_ON)
	rcall ANZEIGE_3_STELLEN_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_RESET_KURZ:
	rcall LCD_CLEAR
	rcall LCD_R
	rcall LCD_E
	rcall LCD_S
	rcall LCD_E
	rcall LCD_T
	rjmp LCD_PUNKT3
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_SEARCH_KURZ:
	rcall LCD_CLEAR
	rcall LCD_S
	rcall LCD_E
	rcall LCD_A
	rcall LCD_R
	rcall LCD_C
	rcall LCD_H
	rjmp LCD_PUNKT3
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_MESSEN_KURZ:
	rcall LCD_CLEAR
	rcall LCD_M
	rcall LCD_E
	rcall LCD_S
	rcall LCD_S
	rcall LCD_E
	rjmp  LCD_N
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TEXT_BUS_ERROR_KURZ:
	rcall LCD_CLEAR
	rcall LCD_B
	rcall LCD_U
	rcall LCD_S
	rcall LCD_SPACE
	rcall LCD_E
	rcall LCD_R
	rcall LCD_R
	rcall LCD_O
	rjmp LCD_R
; ##############################################################################
; ##############################################################################
; ##############################################################################


















