;                                                                               
;              |                                          |                     
;          ____|      ____________________________________|_____                
;              |     |     |                              |                     
;  "1" SLOT    |  6  |     9       64                     |                     
;              |_____|                                    |                     
;              |                                       	  |                     
;              |           Samples                     	  |                     
;              |                                       	  |                     
;          ____|                                    ______|_____                
;              |           15                      |      |                     
; "0" SLOT     |           |        60             |  10  |                     
;              |___________________________________|      |                     
;              |                                       	  |                     
;              |                                          |                     
;                                                                               
;                                                      	                        
;          ____                    ______          _______________|             
;              |                  |      |        |               |             
; RESET        |                  |      |        |               |             
;              |__________________|      |________|               |             
;               <------480--------><---70----><--------410------->|             
;                                                                 |             
;                                                                               
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INITIALISIERUNG																
;																				
OW_INITIALISIERUNG:
	; DATENBUS											
	cbi (OW_DDR), (OW_PIN_NR)				; AUF EINGANG	
	sbi (OW_PORT),(OW_PIN_NR)				; PULL-UP ein	
	rcall WAIT_100ms
	sbi (OW_PORT),(OW_PIN_NR)				; HIGH			
	sbi (OW_DDR), (OW_PIN_NR)				; AUF AUSGANG	

	rcall OW_R_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Widerstand ca. 1k																
OW_R_ON:
	sbi (OW_R_PORT),(OW_R_PIN_NR)				; HIGH			
	sbi (OW_R_DDR), (OW_R_PIN_NR)				; AUF AUSGANG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Widerstand ca. 1k																
OW_R_OFF:
	cbi (OW_R_DDR), (OW_R_PIN_NR)				; AUF EINGANG	
	cbi (OW_R_PORT),(OW_R_PIN_NR)				; PULL-UP off	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_BUS_POWER_CHECK:
	sbic (OW_DDR),(OW_PIN_NR) 	; "skip if..."	
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU aus		
	sbis (OW_DDR),(OW_PIN_NR) 	; "skip if..."	
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)	; BLAU an		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; GELB leuchtet, wenn Kurzschluss auf BUS										
OW_BUS_CHECK:
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus		
	ldi temp9,10
OW_BUS_CHECK_s:
	sbic (OW_PIN),(OW_PIN_NR) 	; "skip if..."	
	ret	
	rcall wait_1ms
	sbic (OW_PIN),(OW_PIN_NR) 	; "skip if..."	
	ret	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an		
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus		
	rcall wait_10ms
	dec temp9
	brne OW_BUS_CHECK_s
; ------------------------------------------------------------------------------
	; ERROR					
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	sbi (OW_PORT),(OW_PIN_NR)	; PULL-UP ein	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR		; ROT  an		
	ldi temp,(ERROR_OW_BUS)
	STS(adr_ERROR_CODE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; OUT: CARRY	0=ERROR 1=OK													
;																				
OW_RESET_PRESENCE_C:
	sbis (OW_PIN),(OW_PIN_NR) 	; PIN auf HIGH ?
	rjmp OW_RP_ERROR
; ------------------------------------------------------------------------------
; RESET-PRESENCE-IMPULS										
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an		
	sbi (OW_DDR), (OW_PIN_NR)	; AUF AUSGANG	
	cbi (OW_PORT),(OW_PIN_NR)	; AUF LOW		
	rcall WAIT_500us						; PAUSE 500us	
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 	
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
; ------------------------------------------------------------------------------
; SAMPLES													
	rcall WAIT_50us							; PAUSE 70us	
	rcall WAIT_10us
	rcall WAIT_10us
	sbic (OW_PIN),(OW_PIN_NR) 	; SAMPLES		
	rjmp OW_RP_ERROR
; ------------------------------------------------------------------------------
; WARTEN auf BUS-HIGH						
OW_RP_s:
	sbis (OW_PIN),(OW_PIN_NR)  	; PIN auf HIGH ?
	rjmp OW_RP_s
; ------------------------------------------------------------------------------
	rcall WAIT_500us						; PAUSE 500us	
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 	
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN an		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  aus		
	SEC										; CARRY=1		
	ret
; ------------------------------------------------------------------------------
OW_RP_ERROR:
	rcall WAIT_500us						; PAUSE 500us	
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 	
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus		
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG	
	ldi temp,(ERROR_OW_RESET_PRESENCE)
	STS(adr_ERROR_CODE),temp
	CLC										; CARRY=0		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 DATENBYTE 1-wire schreiben													
;																				
; inp: temp1																	
;																				
OW_BYTE_WRITE_TEMP1:
	LSR temp1						; 1x rechts 1 rollt raus (LSB)
	rcall OW_BIT_WRITE_C			; BIT-0 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall OW_BIT_WRITE_C			; BIT-1 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall OW_BIT_WRITE_C			; BIT-2 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall OW_BIT_WRITE_C			; BIT-3 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall OW_BIT_WRITE_C			; BIT-4 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall OW_BIT_WRITE_C			; BIT-5 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall OW_BIT_WRITE_C			; BIT-6 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus (MSB)
	rcall OW_BIT_WRITE_C			; BIT-7 schreiben			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DATEN-BIT schreiben															
;																				
; Hier kommt es auf Zeiten an, stimmen die Zeiten nicht, werden die BITs vom	
; MASTER an den SLAVE nicht genau gelesen ! (ggf. mit OSZI prfen)				
;																				
; INP: CARRY																	
;																				
OW_BIT_WRITE_C:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an	
	brcs OW_WRITE_1SLOT				; wenn CARRY=1 dann 1-SLOT	
;-------------------------------------------------------------------------------
OW_WRITE_0SLOT:
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 				
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG				
	cbi (OW_PORT),(OW_PIN_NR)	; LOW-PEGEL					
	rcall WAIT_10us				; PAUSE 60us				
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 				
	cbi (OW_DDR) ,(OW_PIN_NR)	; AUF EINGANG				
	rcall WAIT_10us							; PAUSE 10us				
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus	
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG				
ret
;-------------------------------------------------------------------------------
OW_WRITE_1SLOT:
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 				
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG				
	cbi (OW_PORT),(OW_PIN_NR)	; LOW-PEGEL					
	rcall WAIT_5us				; Pause 6us					
	nop
	nop
	nop
	nop
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 				
	cbi (OW_DDR) ,(OW_PIN_NR)	; AUF EINGANG				
	rcall WAIT_10us				; PAUSE 64us				
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_5us
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus	
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 DATENBYTE 1-wire lesen														
;																				
; out: temp1																	
;																				
OW_BYTE_READ_TEMP1:
	clr temp1
	rcall OW_BIT_READ_C		; LSB					
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	rcall OW_BIT_READ_C
	ROR temp1						; 1x rechts ber CARRY 	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ein BIT vom SLAVE einlesen													
;																				
; Hier kommt es auf Zeiten an, stimmen die Zeiten nicht, werden die BITs vom	
; MASTER an den SLAVE nicht genau gelesen ! (ggf. mit OSZI prfen)				
;																				
; OUT: CARRY																	
;																				
OW_BIT_READ_C:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB an		
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 	
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG	
	cbi (OW_PORT),(OW_PIN_NR)	; LOW-PEGEL		
	nop										; Pause 6us		
	nop
	nop
	nop
	nop
	nop
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	nop										; Pause 9us		
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	; MASTER SAMPLES			
	sbic (OW_PIN),(OW_PIN_NR) 	; "skip if..."	
	rjmp OW_READ_1_SLOT
	rjmp OW_READ_0_SLOT
;-------------------------------------------------------------------------------
OW_READ_0_SLOT:
	rcall WAIT_10us							; 55us warten		
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	nop
	nop
	nop
	nop
	nop
	CLC										; CARRY clear	
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 	
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus		
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG				
	ret
;-------------------------------------------------------------------------------
OW_READ_1_SLOT:
	rcall WAIT_10us							; 55us warten		
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	rcall WAIT_10us
	nop
	nop
	nop
	nop
	nop
	SEC										; CARRY setzen	
	sbi (OW_PORT),(OW_PIN_NR)	; HIGH-PEGEL 	
	cbi (OW_DDR), (OW_PIN_NR)	; AUF EINGANG	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)	; GELB aus		
	sbi (OW_DDR) ,(OW_PIN_NR)	; AUF AUSGANG				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_SCRATCHPAD_CLEAR:
	STS(adr_SCRATCHPAD+0),NULL
	STS(adr_SCRATCHPAD+1),NULL
	STS(adr_SCRATCHPAD+2),NULL
	STS(adr_SCRATCHPAD+3),NULL
	STS(adr_SCRATCHPAD+4),NULL
	STS(adr_SCRATCHPAD+5),NULL
	STS(adr_SCRATCHPAD+6),NULL
	STS(adr_SCRATCHPAD+7),NULL
	STS(adr_SCRATCHPAD+8),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_ROM_CLEAR:
	STS(adr_ROM_ID+0),NULL
	STS(adr_ROM_ID+1),NULL
	STS(adr_ROM_ID+2),NULL
	STS(adr_ROM_ID+3),NULL
	STS(adr_ROM_ID+4),NULL
	STS(adr_ROM_ID+5),NULL
	STS(adr_ROM_ID+6),NULL
	STS(adr_ROM_ID+7),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_ROM_LISTE_CLEAR:
	ldi XL,LOW (adr_ROM_LISTE)	 
	ldi XH,HIGH(adr_ROM_LISTE)
	clr temp
OW_ROM_LISTE_CLEAR_s:
	ST X+,NULL
	cpi XH,HIGH(adr_ROM_LISTE+512)
	brne OW_ROM_LISTE_CLEAR_s
	cpi XL,LOW (adr_ROM_LISTE+512)
	brne OW_ROM_LISTE_CLEAR_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OW_SCRATCHPAD_READ:
	rcall OW_SCRATCHPAD_CLEAR				; CLEAR		
	rcall OW_RESET_PRESENCE_C				; RESET-PRESENCE
	brcs OW_SCRATCHPAD_READ_RUN
	ret
;-------------------------------------------------------------------------------
OW_SCRATCHPAD_READ_RUN:
	ldi temp1,0x55 								; MATCH-ROM	
	rcall OW_BYTE_WRITE_TEMP1
	
	LDS temp1,(adr_ROM_ID+0)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+1)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+2)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+3)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+4)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+5)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+6)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
	LDS temp1,(adr_ROM_ID+7)			; ROM-ID	
	rcall OW_BYTE_WRITE_TEMP1
;-------------------------------------------------------------------------------
	ldi temp1,0xBE 								; SCRATCHPAD-read
	rcall OW_BYTE_WRITE_TEMP1

	rcall OW_BYTE_READ_TEMP1				; auslesen	
	STS(adr_SCRATCHPAD+0),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+1),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+2),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+3),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+4),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+5),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+6),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+7),temp1
	rcall OW_BYTE_READ_TEMP1				
	STS(adr_SCRATCHPAD+8),temp1

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ROM auslesen, nur ein SLAVE vorhanden !										
;																				
; OUT: CARRY, SRAM (adr_ROM_CRC_BEREICH)										
;																				
OW_SINGLE_ROM_READ:
	rcall OW_ROM_CLEAR						; CLEAR				
	rcall OW_RESET_PRESENCE_C			; RESET-PRESENCE	
	brcs OW_SINGLE_ROM_READ_RUN			; CARRY=1 ==> SPRUNG
	ret
;-------------------------------------------------------------------------------
OW_SINGLE_ROM_READ_RUN:
	ldi	temp1,0x33						; MASTER TX x33 (read ROM)	
	rcall OW_BYTE_WRITE_TEMP1
	; MASTER RX 8 BYTE und im SRAM ablegen		
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+0),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+1),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+2),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+3),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+4),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+5),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+6),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_ROM_ID+7),temp1
	; ROM CRC- CHECK							
	rcall ROM_CRC7_C						; OUT: CARRY		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD auslesen, nur ein SLAVE vorhanden !								
;																				
; OUT: CARRY, SRAM (adr_SCRATCHPAD_CRC_BEREICH)									
;																				
OW_SINGLE_SCRATCHPAD_READ:
	; CLEAR												
	rcall OW_SCRATCHPAD_CLEAR
	; RESET												
	rcall OW_RESET_PRESENCE_C				; RESET-PRESENCE
	brcs OW_SINGLE_SCRATCHPAD_READ_RUN
	ret
;-------------------------------------------------------------------------------
OW_SINGLE_SCRATCHPAD_READ_RUN:
	; MASTER TX xCC (SKIP ROM)							
	ldi	temp1,0xCC
	rcall OW_BYTE_WRITE_TEMP1
	; MASTER TX xBE (read SCRATCHPAD)					
	ldi	temp1,0xBE			
	rcall OW_BYTE_WRITE_TEMP1
	; MASTER RX 9 BYTE und im SRAM ablegen		
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+0),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+1),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+2),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+3),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+4),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+5),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+6),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+7),temp1
	rcall OW_BYTE_READ_TEMP1
	STS(adr_SCRATCHPAD+8),temp1
	; CRC CHECK													
	rcall SCRATCHPAD_CRC8_C
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CRC Berechnung bernommen und abgendert von: http://s-huehn.de				
; CRC-Berechnung Application Note 27 von Dallas/Maxim							
;																				
; INP: SRAM(adr_ROM_CRC_BEREICH)												
; OUT: CARRY + R0(CRC-WERT)														
;																				
ROM_CRC7_C:
	push XL          						; auf dem Stack sichern            
	push XH
	push r16
	push r17
	push r18
	push r19
	push r20
	push r21
 	ldi XL,low (adr_ROM_ID) 		; X-Zeiger 					
    ldi XH,high(adr_ROM_ID) 
    ldi     r19, 7                          ;7 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            	;CRC-Startwert = 0 setzen
ROM_CRC7_100: 
	ld      r18, x+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
ROM_CRC7_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    ROM_CRC7_300                    ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
ROM_CRC7_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    ROM_CRC7_200               ;nein -> Schleife
    dec     r19                             ;alle Bytes bearbeitet?
    brne    ROM_CRC7_100               ;nein -> Schleife
;-------------------------------------------------------------------------------
	mov R0,R17							; CRC nach R0 speichern		
	LDS r16,(adr_ROM_ID+7)
	cp r16,r17
	brne ROM_CRC7_ERROR
;-------------------------------------------------------------------------------
; OK																			
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN an	
	SEC										; CARRY=1	
	rjmp ROM_CRC7_FERTIG
;-------------------------------------------------------------------------------
; ERROR 																		
ROM_CRC7_ERROR:
	LDS temp,(adr_CRC_ON)
	tst temp
	brne ROM_CRC7_ERROR_w
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an	
	SEC										; CARRY=1	
	rjmp ROM_CRC7_FERTIG
;-------------------------------------------------------------------------------
ROM_CRC7_ERROR_w:
	ldi R16,(ERROR_OW_CRC)
	STS(adr_ERROR_CODE),R16
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an	
	CLC										; CARRY=0	
;-------------------------------------------------------------------------------
ROM_CRC7_FERTIG:
	pop r21      							; wiederherstellen                	
	pop r20
	pop r19
	pop r18
	pop r17
	pop r16
	pop XH
	pop XL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SCRATCHPAD_CRC8_C:
 	ldi ZL,low (adr_SCRATCHPAD+0) 		; Z-Zeiger 					
    ldi ZH,high(adr_SCRATCHPAD+0) 
    ldi     r19, 8                          ;8 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            	;CRC-Startwert = 0 setzen
SCRATCHPAD_CRC8_100: 
	LD      r18, Z+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
SCRATCHPAD_CRC8_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    SCRATCHPAD_CRC8_300             ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
SCRATCHPAD_CRC8_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    SCRATCHPAD_CRC8_200        		;nein -> Schleife		
    dec     r19                             ;alle Bytes bearbeitet?	
    brne    SCRATCHPAD_CRC8_100    		 	;nein -> Schleife		
;-------------------------------------------------------------------------------
	; Ergebnis in R17	
	LD R16,Z
	cp R16,R17
	brne SCRATCHPAD_CRC8_ERROR
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN an	
	SEC										; CARRY=1	
	ret
;-------------------------------------------------------------------------------
SCRATCHPAD_CRC8_ERROR:
	LDS temp,(adr_CRC_ON)
	tst temp
	brne SCRATCHPAD_CRC8_ERROR_w
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an	
	SEC										; CARRY=1	
	ret
;-------------------------------------------------------------------------------
SCRATCHPAD_CRC8_ERROR_w:
	ldi temp,(ERROR_OW_SCRATCHPAD_CRC)
	STS(adr_ERROR_CODE),temp
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN aus	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an	
	CLC										; CARRY=0	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
