; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR																
PORT_REGISTER_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	

	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR) ,(LED_ROT_PIN_NR)			; ROT		
	sbi (LED_BLAU_DDR),(LED_BLAU_PIN_NR)		; BLAU		
	sbi (BEEP_DDR)    ,(BEEP_PIN_NR)			; BEEP		
	; LEDs an									
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)		; BLAU an	
	cbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP an	
	sbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP aus	
	rcall wait_100ms
	; LEDs aus									
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	sbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)		; BLAU aus	
	sbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_INITIALISIERUNG:
	; auf EINGANG						
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR) 
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR) 
	cbi (TASTE_C_DDR),(TASTE_C_PIN_NR) 
	cbi (TASTE_D_DDR),(TASTE_D_PIN_NR) 
	cbi (TASTE_E_DDR),(TASTE_E_PIN_NR) 
	cbi (TASTE_F_DDR),(TASTE_F_PIN_NR) 	
	; PULL UP ein						
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR) 		
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR) 		
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR) 		
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR) 		
	sbi (TASTE_E_PORT),(TASTE_E_PIN_NR) 		
	sbi (TASTE_F_PORT),(TASTE_F_PIN_NR) 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_KURZ:
	cbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP an	
	rcall wait_10ms
	sbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_LANG:
	cbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP an	
	rcall wait_1s
	sbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE:
	; TASTEN-WAIT			
	LDS temp,(adr_TASTE)
	tst temp
	breq TASTEN_ABFRAGE_RUN
	rcall WAIT_100ms
	rcall WAIT_100ms
	rcall WAIT_100ms
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_RUN:
	clr temp
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)	; springe, wenn...	
	ori	temp,0b00000001			; 1 
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn...	
	ori	temp,0b00000010			; 2	
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)	; springe, wenn...	
	ori	temp,0b00000100			; 4	
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)	; springe, wenn...	
	ori	temp,0b00001000			; 8 
	sbis (TASTE_E_PIN),(TASTE_E_PIN_NR)	; springe, wenn...	
	ori	temp,0b00010000			;16 
	sbis (TASTE_F_PIN),(TASTE_F_PIN_NR)	; springe, wenn...	
	ori	temp,0b00100000			;32 
	STS(adr_TASTE),temp					; save				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
; SCHLEIFE																		
PROGRAMM_CHECK_FEHLER:
	CLI											; INTERRUPTS sperren	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
STOP_PROGRAMM:
	WDR
	rjmp STOP_PROGRAMM
; ##############################################################################
; ##############################################################################
; ##############################################################################
RESET_WDR:
	CLI 										; Global Interrupt Disable
	cbi (BEEP_PORT)    ,(BEEP_PIN_NR)			; BEEP an	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	cbi (LED_BLAU_PORT),(LED_BLAU_PIN_NR)		; BLAU an	
RESET_WDR_s:
	rjmp RESET_WDR_s
; ##############################################################################
; ##############################################################################
; ##############################################################################











